# makefile for building  tlapackdet directly from fortran
# select a concrete compiler from the list below and uncomment it

## this turns off the suffix rules built into make
.SUFFIXES:

## this turns off the RCS / SCCS implicit rules of GNU Make
%: RCS/%,v
%: RCS/%
%: %,v
%: s.%
%: SCCS/s.%

## if a rule fails, delete $@
.DELETE_ON_ERROR:


SYSTYPE := "ifort"
# SYSTYPE := "lahey"
# SYSTYPE := "gfortran"

########################################
## For Intel fortran
ifeq ($(SYSTYPE),"ifort")
 FC = ifort  # Intel fortran
 FFLAGS_FIX= -c -O -132 -g -CB -traceback -zero -save
 FFLAGS_FIX= -c -O3 -132
 FFLAGS := -free
 FFLAGS := $(FFLAGS_FIX) $(FFLAGS)
#define
 FFLAGS := $(FFLAGS) -D__INTEL
# FFLAGS_FIX = -c -save -zero -132 -O3 -fpe0 -no-ftz
# FFLAGS_FIX = -c -save -zero -132 -O3 -fp-model strict

#LIBS=-lcfitsio -lnag21di -lfftw3
#LIBS=-lcfitsio -lfftw3 -lpgplot -lpng -lX11
#LIBS=-lcfitsio  /usr/lib/libfftw3.a
#LIBS=-lutils_10 -lcfitsio -lnag21di -lfftw3
# BINDIR=../../bin/
#LIBDIR=/afs/mpa/home/churazov/ESOFT/lib/

#VPATH=$(LIBDIR): /afs/rzg/amd64_sles9/lib
#LIBDIR=/afs/rzg/amd64_sles9/lib/
#LIBDIR=/usr/lib/
 LIBDIR=
# LIBS= -llapack -L$(HOME)/lib/ -ltest_mat -lsparse -llnag
LIBS= 

 LDFLAGS = -i-dynamic

#examples of other LIBS:
#  LIBS= $(HOME)/lib/libsparse.a $(HOME)/lib/liblnag.a  -lpng -lpgplot -lX11
#   LIBS= $(HOME)/lib/libsparseStr.a $(HOME)/lib/liblnagStr.a  -lpng -lpgplot -lX11
#  LIBDIRSYS =
# for supermongo calls from fortran, depending on sm installation:
#  LIBSM = /usr/local/lib/libplotsub.a \
#        /usr/local/lib/libdevices.a \
#        /usr/local/lib/libutils.a
#  -L/usr/lib -lX11

#-lsocket -lnsl

# -L /opt/X11R6.4/lib -lX11
endif
########################################


## For Lahey-Fujutsu fortran
ifeq ($(SYSTYPE),"lahey")
  FC = lf95  # Lahey-fujutsu fortran
  LDR  = $(FC)
  FFLAGS_FIX = -Cpp -c  --sav --ap --o2
  FFLAGS :=
  FFLAGS := $(FFLAGS_FIX) $(FFLAGS)
#  FFLAGS = -c  --sav -g  --trap  --ap   --chkglobal   --pca # debug
#  FFLAGS = -c  -sav --trap  --tpp   --o2   --ntrace   --f95   --info
#  FFLAGS = -c  -sav  --tpp   --o2   --ntrace   --f95   --info
 LIBS=-lcfitsio -lfftw3
#   LIBS= $(HOME)/lib/libsparself.a $(HOME)/lib/liblnaglf.a  -lpng -lpgplot -lX11
#   LIBSM = /usr/local/lib/libplotsub.a \
#        /usr/local/lib/libdevices.a \
#        /usr/local/lib/libutils.a -L/usr/lib -lX11
  LDFLAGS =
endif
########################################

## For gfortran
ifeq ($(SYSTYPE),"gfortran")
  FC = gfortran
  # FFLAGS = -c -O -finit-local-zero -fno-automatic -Wall # for g77
 FFLAGS_FIX = -c -O2 -ffixed-line-length-132 -fexpensive-optimizations -finit-local-zero -fno-automatic -Wall
 FFLAGS_FIX = -c -g -O0 -ffixed-line-length-132 -finit-local-zero  -Wall
# -fno-automatic is not allowed for matdecfundet.f90 and lapackfundet.f90 in older versions of gfortran
#   FFLAGS_FIX = -c -O2 -ffixed-line-length-132 -fexpensive-optimizations -finit-local-zero -Wall
  # FFLAGS = -c -g -fbounds-check -finit-local-zero -fno-automatic # for g77
  FFLAGS := $(FFLAGS_FIX) $(FFLAGS)
#   LIBS= -L/usr/local/lib -llapack -ltmglib -lrefblas -L$(HOME)/lib/ -ltest_mat -lsparseGF -llnagGF
#  LIBS= -L/usr/local/lib -llapack -ltmglib -lrefblas -L$(HOME)/lib/ -lsparseGF -llnagGF
#   LIBS=  -llapack  -L$(HOME)/lib/
  LIBS= 
#   LIBS= $(HOME)/lib/gfsparse.a $(HOME)/lib/gflnag.a -L/home/blinn/APUS/bin/pgplot -lpgplot -lpng -lX11
#   LIBDIRSYS =
#   LIBSM = /usr/local/lib/libplotsub.a \
#         /usr/local/lib/libdevices.a \
#         /usr/local/lib/libutils.a -L/usr/lib -lX11
  LDFLAGS =
endif
########################################


DEL = rm -f


PROG_almatr = xalargematr.exe
OBJS_almatr := tLargematrAlone.o lapackfundet.o ma28Timmes.o quicksortN.o test_mat.o \
               dgetrf.o xerbla.o ilaenv.o dgetf2.o dlaswp.o dtrsm.o dgemm.o ieeeck.o \
               iparmq.o lsame.o dlamch.o idamax.o dswap.o dscal.o dger.o

# INCL= include/pi.inc include/fftw3.f

LDFLAGS += -o

TREFOR = -trf
TREFOR95 = -t95
# for ctrf:
TRFFLAGS = -nfs

.IGNORE:

%.o: %.f
	$(FC) $(FFLAGS_FIX) $< $(INCL_DIR)
%.f : %.trf
	$(TREFOR) $(TRFFLAGS) $<
%.f90 : %.trn
	$(TREFOR95) $(TRFFLAGS) $<
%.o %.mod: %.f90
	$(FC) $(FFLAGS) $< $(INCL_DIR)
%.o %.mod: %.F90
	$(FC) $(FFLAGS)  $< $(INCL_DIR)
%.o: %.F
	$(FC) $(FFLAGS)  $<  $(INCL_DIR)

all: help
	@echo current compiler: $(FC)
	@echo and its options : $(FFLAGS)


alargematr: $(OBJS_almatr)
	$(FC) $(LDFLAGS) $(PROG_almatr) $(OBJS_almatr) ${LIBS}


help:
	@echo "You can do: "
	@echo " alargematr     --  compile and build alargematr.exe via tLargematrAlone.trn (no libs)"
	@echo " clean          --  rm -f *.o *.il *.mod *.lst"
	@echo " cleanall       --  rm -f *.o *.mod *.exe core*"
	@echo " help           --  print this help"


# Here are all the additional dependencies:

ma28Timmes.o :  implno.dek



#####################

cleanall:
	$(DEL) *.o *.mod *.exe core*

clean:
	$(DEL) *.o  *.il *.mod *.lst
