!: large_int & real _kind
!           const
!           mypause etc
!                      *
!------- '-->Entering Node %_modules:'

        !- module constants_module
        !- contains parameters for declaring KIND= and the like
        module constants_module
!-            integer, parameter :: large_int_kind = 4
              integer, parameter :: short = selected_int_kind(4)
              integer, parameter :: long = selected_int_kind(8)
!- max for integer
!- i1  127
!- i2  32767
!- i4  2147483647
!- i8  9223372036854775807
!- i16 170141183460469231731687303715884105727 -- not in ifort, but OK in gfortran

!-            integer, parameter :: large_real_kind = 8
!-            integer, parameter :: dp = selected real kind (15,307)
!- Alternate form:
            integer, parameter :: dp = kind (1.d0)
        end module constants_module

        !- module utilities_module
        !- for doing little common things
        module utilities_module
        contains
            subroutine mypause()
            print *, ' Press ENTER to continue'
            read(*,*)
            end subroutine mypause
        end module utilities_module

      module const
      use constants_module
      implicit none
      integer(kind=long), parameter:: nmax=50000_long
!-real(dp), parameter:: Deg Per Rad = 57.295779513082320876798155_dp
!-real(dp), parameter:: Rad Per Deg = 0.017453292519943295769237_dp
!-       real(kind=large_real_kind), parameter:: pi=3.14159265358979312
      real(kind=dp), parameter:: pi=3.14159265358979312_dp
      end module const


!------- '<--Leaving  Node %_modules:'

!Burkardt : subroutines from his library -- now in his file *

program tLargematrAlone

!- similar to tmatr, and tLargematr, for mostly large matrices with interactive input, and less details
!- but for stand-alone test (no libraries)

  use utilities_module

  implicit none

!: variable declarations *
  !  integer(kind=8) :: N
  integer :: N, i, k, iseed, iblock, iend, ibeg, Nminor, sgn, nperm
  real , allocatable, dimension(:,:) :: randArray
  real(kind=8), allocatable, dimension(:,:) :: amat,bmat,cmat,afac,resdeterm
!  complex(kind=8), allocatable, dimension(:,:) :: amat
  real(kind=8), allocatable, dimension(:) :: b,adiag,bdiag,aminor
  real(kind=8) ::  finddet, detans, mddet, afixed(1:2,1:2)
!   complex(kind=8) :: det, detans
  character ( len = 20 ) title
  character ( len = 20 ) fmt, ifmt, fmtminor, ifmtminor, fname
  real ( kind = 8 ) determ1
  real ( kind = 8 ) determ2
  real ( kind = 8 ) r8mat_norm_fro
  real ( kind = 8 ) norm_frobenius
  integer :: nz, nydim, licn, lirn
  parameter(nz=120000);
  parameter(nydim=9000);
  parameter(licn=5*nz,lirn=2*nz); ! for ma28ad & m28y12
  logical :: lblock,grow,abort(4);
!   logical :: needbr,f01,wtyp;
!-   integer, allocatable, dimension(:,:) :: ikeep(:,:)
  integer, dimension(1:5*nydim) :: ikeep
! ikeep  integer array  length 5*n  used as workspace by ma28ad
!     .     (see later comments).  it is not required to be set on
!     .     entry and, on exit, it contains information about the
!     .     decomposition.  it should be preserved between this call
!     .     and subsequent calls to f01bsf or f04axf.
!     ikeep(i,1),i=1,n  holds the total length of the part of row i
!     .     in the diagonal block.
!     row ikeep(i,2),i=1,n  of the input matrix is the ith row in
!     .     pivot order.
!     column ikeep(i,3),i=1,n  of the input matrix is the ith
!     .     column in pivot order.
!     ikeep(i,4),i=1,n  holds the length of the part of row i in
!     .     the l part of the l/u decomposition.
!     ikeep(i,5),i=1,n  holds the length of the part of row i in
!     .     the off-diagonal blocks.  if there is only one diagonal
!     .     block, ikeep(1,5) will be set to -1.

  integer :: iw(8*nydim),idisp(11),nza,ifail
  real ( kind = 8 ) :: thr,hl,ajac(licn),wjac(nydim), &
                fsave(nydim), asave(nz), pivot;
  integer :: irn(lirn),icn(licn),irs(nz),ics(nz);
  integer ( kind = 4 ) info
  integer ( kind = 4 ) ipivot(nydim),iwork(nydim)

! commons for ma28cd, later move to module
      logical          abort1,abort2
      integer          lp,mp,irncp,icncp,minirn,minicn,irank,mtype
      double precision resid,mresid,eps,rmin

      common /ma28fd/  eps,rmin,resid,irncp,icncp,minirn,minicn, &
                       irank,abort1,abort2
      common /ma28gd/  idisp
      common /ma30hd/  mresid

      common /ma28ed/  lp,mp,lblock,grow

!      common /ma28fd/  eps,rmin,resid,irncp,icncp,minirn,minicn, &
!                       irank,abort1,abort2
!      common /ma28gd/  idisp
!      common /ma28hd/  tol,themax,big,dxmax,errmax,dres,cgce, &
!                       ndrop,maxit,noiter,nsrch,istart,lbig
!      common /ma30id/  tol1,big1,ndrop1,nsrch1,lbig1
!      common /ma30ed/  nlp,aborta,abortb,abort3
!      common /ma30fd/  mirncp,micncp,mirank,mirn,micn
!      common /mc23bd/  mlp,numnz,num,large,abort
!      common /lpivot/  lpiv,lnpiv,mapiv,manpiv,iavpiv,ianpiv,kountl
!      *


  data lblock /.false./, & ! switch off lblock to simplify finding diagonal elements after call to ma28ad and m28y12
         grow/.true./ !,  & !  abort/.true.,.true.,.false.,.false./,
!-          abort/.false.,.true.,.false.,.false./ -- for f01brf
!     ABORT  LOGICAL ARRAY LENGTH 4.
!     IF ABORT(1)=TRUE, THE ROUTINE WILL EXIT IMMEDIATELY
!     .     ON DETECTING STRUCTURAL SINGULARITY.
!     IF ABORT(2)=TRUE, THE ROUTINE WILL EXIT IMMEDIATELY
!     .     ON DETECTING NUMERICAL SINGULARITY.
!     IF ABORT(3)=TRUE, THE ROUTINE WILL EXIT IMMEDIATELY WHEN THE
!     .     AVAILABLE SPACE IN A/ICN IS FILLED UP BY THE PREVIOUSLY
!     .     DECOMPOSED ACTIVE, AND UNDECOMPOSED PARTS OF THE MATRIX.
!     IF ABORT(4)=TRUE, THE ROUTINE WILL EXIT IMMEDIATELY
!     .     ON DETECTING DUPLICATE ELEMENTS IN THE INPUT MATRIX.


!: *
!------- '-->Entering Node %_testquicksort:'
  ikeep(1)=3
  ikeep(2)=1
  ikeep(3)=2
  ikeep(4)=5
  ikeep(5)=4
  write(*,'(5i5)')(ikeep(i),i=1,5)
  call quicksort(5,ikeep,nperm)
  write(*,*)' nperm=',nperm
  write(*,'(5i5)')(ikeep(i),i=1,5)
!-   stop

!------- '<--Leaving  Node %_testquicksort:'

!- define N, fmt, ifmt allocate amat, bmat, cmat, etc.

!-   N=4

  write(*,*)'enter N>0'
  read(*,*) N

  write(fname,'(a,i1,a)')'debugDet',min(N,9),'.res'
!-   open(unit=10,file=fname,status='unknown') ! open for debug
  if(N<10)then
   write(fname,'(a,i1,a)')'compDet00',N,'.res'
  elseif(N<100)then
   write(fname,'(a,i2,a)')'compDet0',N,'.res'
  else
   write(fname,'(a,i3,a)')'compDet',N,'.res'
  endif
  open(unit=20,file=fname,status='unknown')

  write(fmt,'("(",i0,"f10.3)")') min(N,10) ! variable format
  write(ifmt,'("(",i0,"i10)")') min(N,10)
!-   write(*,*) fmt


  allocate(resdeterm(3,N))
  allocate(amat(N,N))
  allocate(bmat(N,N))
  allocate(cmat(N,N))
  allocate(afac(N,N))
  allocate(aminor(N*N))
  allocate(randArray(N,N))
  allocate(b(N))
  allocate(adiag(N))
  allocate(bdiag(N))
!-   allocate(ikeep(N,5))


!: define  amat *
!------- '-->Entering Node %_matrix:'



!  for N==3 amat is from John R. Rice
!  MATRIX COMPUTATIONS AND MATHEMATICAL SOFTW ARE

  amat(1,1)=2
  if(N>1 .and. N<4)then
   amat(1,2)=2
   amat(2,1)=6
   amat(2,2)=-1
  endif
  if(N>2 .and. N<4)then
   amat(1,3)=4
   amat(2,3)=1
   amat(3,1)=4
   amat(3,2)=-10
   amat(3,3)=-12
  endif

!
!  call r8mat_determinant ( 2, amat, determ1 )
!  write(*,*)' amat=',amat
!  write(*,*)' determ1=',determ1
! 
!  afixed(1,1)=2
!  afixed(1,2)=2
!  afixed(2,1)=6
!  afixed(2,2)=-1
! 
! 
!  call r8mat_determinant ( 2, afixed, determ2 )
! 
!  write(*,*)' afixed=',afixed
!  write(*,*)' determ2=',determ2
! 
!  call mypause*

  if(N>3)then
   CALL random_seed         ! see example of RANDOM_SEED
   call random_number(randArray)
   do i=1,N
     do k=1,N
       if(randArray(i,k)<.4 .or. randArray(i,k)>.6)then
        amat(i,k)=2d0*dble(randArray(i,k))-1d0
       else
        amat(i,k)=1d0
       endif
     enddo
   enddo
  endif

!-   write(*,*)' initial amat (transposed):'
!-   write(*,fmt) amat
  write(*,*)' initial amat in rows:'
  do i=1,N
   write(*,fmt)(amat(i,k),k=1,N)
  enddo
!-   stop

!------- '<--Leaving  Node %_matrix:'

  bmat=amat
  cmat=amat
!-   aminor=cmat

  do Nminor=N,1,-1

  write(*,*)' entering Loop  Nminor=',Nminor
!-   call mypause

    
!: of size Nminor in aminor *
!------- '-->Entering Node %_minor:'

!-   write(*,*)' entering node minor'
!-   call mypause


  do i=1,Nminor
    do k=1,Nminor
       aminor(i+Nminor*(k-1))=bmat(i,k) ! (i,k) element is in location nrows*(k-1) + i
    enddo
  enddo

!-   write(fmtminor,'("(",i0,"f10.3)")') Nminor ! min(N,10) ! variable format
!-
!-
!-   write(*,*)' initial aminor in rows for Nminor=',Nminor
!-
!-   do i=1,Nminor
!-    write(*,fmtminor)(aminor(i+Nminor*(k-1)),k=1,Nminor)
!-   enddo


!------- '<--Leaving  Node %_minor:'
    
!: find in detans determinant of aminor via finddet (lapack) *
!------- '-->Entering Node %_detans:'

!-   write(*,*)' entering node detans'
!-   call mypause


  detans = finddet(Nminor, aminor)
  write(*,*)' lapack finddet det=', detans
  resdeterm(1,Nminor)=detans

 !redefined aminor destroyed by finddet

  do i=1,Nminor
    do k=1,Nminor
       aminor(i+Nminor*(k-1))=cmat(i,k)
!-        if(Nminor==2) write(*,*)' i,k,aminor,afixed:',i,k,aminor(i+k*(Nminor-1)),afixed(i,k)
    enddo
  enddo

!-   write(fmtminor,'("(",i0,"f10.3)")') Nminor ! min(N,10) ! variable format


!-   write(*,*)' redefined aminor in rows for Nminor=',Nminor

!-   do i=1,Nminor
!-    write(*,fmtminor)(aminor(i+Nminor*(k-1)),k=1,Nminor)
!-   enddo
!-
!-   write(10,*)'N,Nminor before r8mat_gefa and aminor:',N,Nminor
!-   write(10,'(2f10.3)') aminor

!-   call r8mat_gefa ( aminor, afac, Nminor, ipivot, info ) ! afac added in debug version
  call r8mat_gefa ( aminor, Nminor, ipivot, info )

  write(*,*)' ipivot=',ipivot(1:Nminor)

!-   call mypause


!-   call r8mat_gedet ( afac, Nminor, ipivot, determ2 ) ! afac in debug version
  call r8mat_gedet ( aminor, Nminor, ipivot, determ2 )

!-   call r8mat_determinant ( Nminor, aminor, determ2 )
  write(*,*)' r8mat_gedet    det=', determ2
  resdeterm(2,Nminor)=determ2
!-   call mypause


!-   write(*,*)' initial bmat:'
!-   write(*,fmt) bmat
!-   detans = mddet(N, bmat)
!-   write(*,*)' det=', detans

!------- '<--Leaving  Node %_detans:'
  enddo

!- stop

  do Nminor=N,1,-1
      
!: prepare pivot, thr ajac for ma28 (f01brf) and find solution in b
!           and determinants of diagonal minors in determ1 *
!------- '-->Entering Node %_ma28:'


  do i=1,Nminor
    do k=1,Nminor
       aminor(i+Nminor*(k-1))=cmat(i,k)
    enddo
  enddo

  write(fmtminor,'("(",i0,"f10.3)")') Nminor ! min(N,10) ! variable format
  write(ifmtminor,'("(",i0,"i10)")') Nminor ! min(N,10)


  write(*,*)' initial aminor in rows for Nminor=',Nminor

  do i=1,Nminor
   write(*,fmtminor)(amat(i,k),k=1,Nminor)
  enddo


  pivot=.25d0
  thr=1d-2
  nza=0
  do i=1,Nminor;
    do k=1,Nminor;
       nza=nza+1;
       ajac(nza)=aminor(i+Nminor*(k-1));
       asave(nza)=ajac(nza);
       irs(nza)=i;
       ics(nza)=k;
    enddo
  enddo

  
! rhsRice : *

  
!:  *
!------- '-->Entering Node %_ma28_rhsUnity:'

  do i=1,Nminor
    b(i)=0
  enddo
! RHS for x(i)==1:
  do k=1,nza;
      b(irs(k))=b(irs(k))+ajac(k) !- * 1.
  enddo
!-   write(*,*)' first <=10 values for rhs:';
!-   do i=1,min(Nminor,10);
!-       write(*,'(a,i2,a,1p,e10.3)')' i=', i,'    b=', b(i)
!-   enddo

!------- '<--Leaving  Node %_ma28_rhsUnity:'

!-   do is=1,nza;
!-       asave(is)=ajac(is);
!-   enddo

  irn(1:nza)=irs(1:nza)
  icn(1:nza)=ics(1:nza)
!  write(*,*)' nza=',nza
!  write(*,*)' irn=',irn(1:nza)
!  write(*,*)' icn=',icn(1:nza)*
!   pause

!-   write(*,*)'ajac before f01brf';
!-   write(*,fmtminor) (ajac(i),i=1,nza)
!  call f01brf(Nminor, nza, ajac, licn, irn, lirn, icn, pivot, &
!                       ikeep, iw, wjac, lblock, grow, abort, &
!                       idisp, ifail);
!                       *
  abort1=.true.
  abort2=.true.
  call ma28ad(Nminor, nza, ajac, licn, irn, lirn, icn, pivot, &
                       ikeep, iw, wjac, ifail);
!-        subroutine ma28ad(n,nz,a,licn,irn,lirn,icn,u,ikeep,iw,w,iflag)

!-   write(*,*)'after f01brf nza=',nza
!-   write(*,*)' irn=',irn(1:nza) ! this is zero after f01brf
  ! one has to look into m28cys.trf or f04axzt.f to extract rows of decomposed matrix
!-   write(*,*)' icn=',icn(1:nza)
!-   write(*,*)' ikeep:'
!-   write(*,ifmtminor)ikeep(1:5*Nminor)
!   pause
!-   write(*,*)'ajac after f01brf';
!-   write(*,fmtminor) ajac(1:nza)

!-   write(*,*)' iblock holds the position of the first non-zero in the current row'
!-   write(*,*)' iblock=idisp(1), ajac(iblock) =',idisp(1),ajac(idisp(1))
  iblock=idisp(1)
  do i=1,Nminor
!-    iend = iblock + lenrl(i) - 1 = idisp(1) + ikeep(i,4) -1:
!-    if (ikeep(i,1) /= 0)   iend = iblock + ikeep(i,4) -1
   if (ikeep(i) /= 0)   ibeg = iblock + ikeep(i+3*Nminor)
!-    write(*,*)' iend is the end of the l part of row i in the lu decomposition,'
!  write(*,*)' iend, a(iend)=',iend, a(iend)
!-    write(*,*)' ibeg=iend+1 is the diagonal element of row i in the lu decomposition:'
!-    ibeg=iend+1
!-    write(*,*)' ibeg, ajac(ibeg) =',ibeg, ajac(ibeg)
   adiag(i)=ajac(ibeg)
   ! iblock is adjusted to point to the start of the next row.
!-    iblock = iblock + ikeep(i,1)
   iblock = iblock + ikeep(i)
!-    write(*,*)' iblock,lenr(i) =',iblock,ikeep(i,1)
  enddo

  determ1 = 1
!-   sgn = 1
!-   sgn = 0
  write(*,*) ' ikeep(row)  ikeep(col)'
  do i = 1, Nminor
       determ1 = determ1*adiag(i)
!-        if(ikeep(i,2) /= i) sgn = -sgn
       write(*,*) ikeep(i+Nminor), ikeep(i+2*Nminor)
!-        if(ikeep(i+Nminor) /= i) sgn = -sgn
!-        if(ikeep(i,3) /= i) sgn = -sgn
!-        if(ikeep(i+2*Nminor) /= i) sgn = sgn*(-1)**(ikeep(i+2*Nminor) - i)
!-        if(ikeep(i+2*Nminor) /= i) sgn = sgn + 1
  end do
  call mypause

  write(*,*)'ma28ad sgn, sgn/2=', sgn, sgn/2
  iwork(1:Nminor)=ikeep(1+2*Nminor:3*Nminor)
  call quicksort(Nminor,iwork,nperm)
  sgn = (-1)**nperm
  determ1 = sgn*determ1
  bdiag(Nminor)=sgn*adiag(Nminor)
  write(*,*)'ma28ad det=', determ1
  resdeterm(3,Nminor)=determ1
!-   call mypause

  call ma28cd(Nminor,ajac,licn,icn,ikeep,b,wjac,1);
! subroutine ma28cd(n,a,licn,icn,ikeep,rhs,w,mtype)
!   on exit the solution must be in b
  write(*,*)'solution after ma28cd';
  write(*,fmtminor) b(1:Nminor)
!-   call mypause


!
!  ajac(1:nza)=asave(1:nza)
!  irn(1:nza)=irs(1:nza)
!  icn(1:nza)=ics(1:nza)
!  write(*,*) 'ajac before m28y12';
!  write(*,fmt) ajac(1:nza)
!  call m28y12(n, nza, ajac, licn, irn, lirn, icn, pivot, &
!                       ikeep, iw, wjac, lblock, grow, abort, &
!                       idisp, ifail, thr);
! 
!  write(*,*)'after m28y12 nza=',nza
!  write(*,*)'ajac after m28y12';
!  write(*,fmt) ajac(1:nza)
!  pause
!  *

!------- '<--Leaving  Node %_ma28:'
     write(20,'(1p,3g12.3,11i5,20(10i5))')(resdeterm(i,Nminor),i=1,3),sgn,(ikeep(i+2*Nminor),i=1,Nminor)
  enddo

  write(20,'(/a)')' diagonal of the largest decomposed matrix:'
  write(20,'(1p,2g12.3)') (adiag(i),bdiag(i),i=1,N)

  deallocate (resdeterm)
  deallocate (amat)
  deallocate (bmat)
  deallocate (cmat)
  deallocate (afac)
  deallocate(aminor)
  deallocate(randArray)
  deallocate(b)
  deallocate(adiag)
!-   deallocate(ikeep)

  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) 'TEST_DETERMINANT'
  write ( *, '(a)' ) '  Compute the determinants of an example of each'
  write ( *, '(a)' ) '  test matrix; compare with the determinant routine,'
  write ( *, '(a)' ) '  if available.  Print the matrix Frobenius norm'
  write ( *, '(a)' ) '  for an estimate of magnitude.'
  write ( *, '(a)' ) ' '
  write ( *, '(a)' ) '  Matrix title             N      ' // &
                     'Determ          Determ         ||A||'
  write ( *, '(a)' ) ' '

!
!  AEGERTER matrix.
!
  title = 'AEGERTER'
  N = 3
  allocate ( amat(1:N,1:N) )
  allocate ( bmat(1:N,1:N) )
  allocate ( cmat(1:N,1:N) )
  call aegerter ( N, amat )
  bmat=amat
  cmat=amat
  call aegerter_determinant ( N, determ1 )
  call r8mat_determinant ( N, amat, determ2 )
  norm_frobenius = r8mat_norm_fro ( N, N, amat )
  write ( *, '(2x,a20,2x,i4,2x,g14.6,2x,g14.6,2x,g14.6)' ) &
    title, N, determ1, determ2, norm_frobenius

  write(*,*)' initial bmat:'
  write(*,fmt) bmat
  detans = finddet(N, bmat)
  write(*,*)' det=', detans

!-   write(*,*)' initial cmat:'
!-   write(*,fmt) cmat
!-   detans = mddet(N, bmat)
!-   write(*,*)' det=', detans

  deallocate (amat)
  deallocate (bmat)
  deallocate (cmat)

end program tLargematrAlone

